#ifndef _control_h_
#define _control_h_

#include <stdlib.h>

#include "MyHamster.h"
#include "list.h"
#include "point.h"


enum Direction {none=0, north=1, south=2, east=8, west=4};       /* eigene Richtungsdefinition */


typedef struct {
  MyHamster *myhamster;
  Iterator position;/*   struct MyData *position; */
} Control;

void take(Control *);

void turn_to_dir(Control *, int);

void turn_north(Control *);
void turn_south(Control *);
void turn_west(Control *);
void turn_east(Control *);

void turn_left(Control *);
void turn_right(Control *);

void turn(void (*)(Control *), Control *);/*drehen*/


void go_step(Control *);

void go_dir(Control *, enum Direction);

void go_north(Control *);
void go_south(Control *);
void go_west(Control *);
void go_east(Control *);

void go_next(Control *);
void go_back(Control *);

void go_start(Control *);
void go_end(Control *);

void go(void (*)(Control *), Control *);/*gehen*/

void look_field(Control *);

int look_dir(Control *);/*ueberpruefen, ob in richtung sehen*/
/* void scanlook_dir(Control *);*/

/* void look_north(Control *); */
/* void look_south(Control *); */
/* void look_east(Control *); */
/* void look_west(Control *); */

void look(void (*)(Control *), Control *);/*sehen*/

void scan_dir(Control *);


void scan(Control *);
void scan_start(Control *);

int search(Control *, Point *);
void decide_dir(Control *);


void append_s(Control *);
void append_f(Control *);
void erase_f(Control *);
void erase_s(Control *);

#endif
