#include "list.h"

#include <stdio.h>
#include <stdlib.h>


/*
 * Definition aller Funktionen
 */

List *init_List(Function f) {
  List *l = malloc(sizeof(List));
  
  l->root = malloc(sizeof(Item));
  l->root->next = l->root;
  l->root->prev = l->root;
  l->length = 0;
  l->out_Function = f;
  
  return l;
}

Iterator begin(List *l) {
  Iterator iter = {l->root->next};
  
  return iter;
}

Iterator end(List *l) {
  Iterator iter = {l->root};
  
  return iter;
}

Iterator next(Iterator iter) {/*++i*/
  iter.item = iter.item->next;
  
  return iter;
}

Iterator prev(Iterator iter) {/*--i*/
  iter.item = iter.item->prev;
  
  return iter;
}


Iterator insert(List *l, Iterator iter, const Type node) {
  Item *li = malloc(sizeof(Item));
  Iterator riter = {li};
  li->node = node;
  
  li->next = iter.item;
  li->prev = li->next->prev;
  li->prev->next = li;
  li->next->prev = li;
  
  ++l->length;
  return riter;
}


void push_front(List *l, const Type node) {
  insert(l, begin(l), node);
}

void push_back(List *l, const Type node) {
  insert(l, end(l), node);
}


void erase(List *l, Iterator iter) {
  iter.item->prev->next = iter.item->next;
  iter.item->next->prev = iter.item->prev;
  
  --l->length;
  free(iter.item);
}

void erase_from_to(List *l, Iterator first, Iterator last) {
  while(first.item != last.item) {
    erase(l, first);
    first = next(first);
  }
}

void erase_List(List *l) {
  erase_from_to(l, begin(l), end(l));
}

void pop_front(List *l) {
  erase(l, begin(l));
}

void pop_back(List *l) {
  erase(l, prev(end(l)));
}

int empty(List *l) {
  return (l->length==0);
}

int size(List *l) {
  return l->length;
}



Function for_each(List *l, Iterator first, Iterator last, Function f) {
  for( ; first.item != last.item; first = next(first)) f(first);
  
  return f;
}


Function for_each_next(List *l, Iterator first, Iterator last, Function f) {
  for( ; first.item != last.item; first = next(first)) f(first);
  
  return f;
}


Function for_each_prev(List *l, Iterator first, Iterator last, Function f) {
  for( ; last.item != first.item; last = prev(last)) f(last);
  
  return f;
}


/* void out_Int(Iterator iter) { */
/*   printf("%i ", iter.item->node.i); */
/* } */

/* void out_Float(Iterator iter) { */
/*   printf("%f ", iter.item->node.f); */
/* } */

/* void out_Oct(Iterator iter) { */
/*   printf("%o ", iter.item->node.i); */
/* } */

/* void out_Char(Iterator iter) { */
/*   printf("%c ", iter.item->node.c); */
/* } */

/* void out_String(Iterator iter) { */
/*   printf("%s ", (char *) iter.item->node.aptr); */
/* } */


void out_List(List *l) {
  fprintf(stderr,"<\n ");
  for_each(l, begin(l), end(l), l->out_Function);
  fprintf(stderr,">\n");
}


/* void out_List_X(Iterator iter) { */
/*   List *l = (List *) iter.item->node.aptr; */
  
/*   out_List(l); */
/*   printf(" "); */
/* } */
