#ifndef _list_h_
#define _list_h_

/*
 * Deklaration aller Strukturen
 */


typedef void *Type;

typedef struct _Item {
  Type node;
  
  struct _Item *next;
  struct _Item *prev;
} Item;

typedef struct {
  Item *item;
} Iterator;

typedef void (*Function) (Iterator);

typedef struct {
  Item *root;
  Function out_Function;
  
  int length;
} List;

/*
 * Deklaration aller Funktionen
 */

List *init_List(Function);

Iterator begin(List *);
Iterator end(List *);
Iterator next(Iterator);
Iterator prev(Iterator);

Iterator insert(List *, Iterator, const Type);
void push_front(List *, const Type);
void push_back(List *, const Type);

void erase(List *, Iterator);
void erase_from_to(List *, Iterator, Iterator);
void erase_List(List *);
void pop_front(List *);
void pop_back(List *);

int empty(List *);
int size(List *);

Function for_each(List *, Iterator, Iterator, Function);
Function for_each_next(List *, Iterator, Iterator, Function);
Function for_each_prev(List *, Iterator, Iterator, Function);

/* void out_Int(Iterator); */
/* void out_Float(Iterator); */
/* void out_Oct(Iterator); */
/* void out_Char(Iterator); */
/* void out_String(Iterator); */

void out_List(List *);
void out_List_X(Iterator);


#endif
